/*!
 * posterSwing jQuery plugin v1.0
 * http://dailycoding.com/
 */

(function (jQuery) {

    jQuery.fn.posterSwing = function (options) {

        var src = this;

        // Setting up default options.
        var settings = jQuery.extend({
            // These are the defaults.
            duration: 4000,
            angle: 30,
            swingCenter: "50% 5%"
        }, options);

        jQuery(this).css({ "transform-origin": settings.swingCenter });

        this.stop(true, true).animate(
            {
                rotation: settings.angle
            },
            {
                duration: settings.duration,
                step: function (now, fx) {
                    jQuery(this).css({ "transform": "rotate(" + now + "deg)" });
                },
                easing: "poster",
                complete: function () {
                    
                }
            }
        );

        return this;
    };

    jQuery.easing.poster = function (x, t, b, c, d) {

        var ratio = [0.2, 0.2, 0.2, 0.2, 0.2];
        var ratioSum = [0.2, 0.4, 0.6, 0.8, 1.0];
        var decayFactor = [1, 0.5, 0.25, 0.125, 0.0625];
        decayFactor = [1, 0.6, 0.36, 0.21, 0.12];

        if (t < d * ratioSum[0]) {
            return cycleQuad(x / ratio[0], t, b, c, d * ratio[0]) * decayFactor[0];
        }
        else if (t < d * ratioSum[1]) {
            return cycleQuad((x - c * ratioSum[0]) / ratio[1], t - d * ratioSum[0], b, c, d * ratio[1]) * decayFactor[1]
        }
        else if (t < d * ratioSum[2]) {
            return cycleQuad((x - c * ratioSum[1]) / ratio[2], t - d * ratioSum[1], b, c, d * ratio[2]) * decayFactor[2];
        }
        else if (t < d * ratioSum[3]) {
            return cycleQuad((x - c * ratioSum[2]) / ratio[3], t - d * ratioSum[2], b, c, d * ratio[3]) * decayFactor[3];
        }
        else {
            return cycleQuad((x - c * ratioSum[3]) / ratio[4], t - d * ratioSum[3], b, c, d * ratio[4]) * decayFactor[4];
        }
    };

    function cycleQuad(x, t, b, c, d) {
        var tt = t;
        if (t < d / 4) {
            return -c * (tt /= (d / 4)) * (tt - 2) + b;
        }
        else if (t < d / 2) {
            tt = t - d / 4;
            return 1 - c * (tt /= (d / 4)) * tt + b;
        }
        else if (t < (d * 3) / 4) {
            tt = t - d / 2;
            return c * (tt /= (d / 4)) * (tt - 2) + b;
            //return -(x - 0.5) * 4;
        }
        else {
            tt = t - (d * 3) / 4;
            return -1 + c * (tt /= (d / 4)) * tt + b;
        }
    }

}(jQuery));